<?php
// +--------------------------------------------------------------------------+
// |   phpMyVisites   |   statistiques et mesure d'audience de sites Internet |
// +--------------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Matthieu Aubry. Tous droits rservs             |
// +--------------------------------------------------------------------------+
// | Ce code est distribu sous license GNU GPL, disponible  '/docs/licence' |
// | Pour toute information supplmentaire :     							  |
// | http://www.phpmyvisites.net    |    matthieu@phpmyvisites.net            |
// +--------------------------------------------------------------------------+

/*----------------------------------------------*/
// fichier : functions.php
/*----------------------------------------------*/

// formate les dates pour l'affichage
function display_date($tdate,$jour,$mois,$annee,$aff_jour_fin,$aff_mois_fin, $tgraph=0)
{
	global $lang;

	// normal
	if($tgraph==0)
	{
		$tdate = str_replace('%daylong%', $lang['jsemaine'][date("D",mktime(0,0,0,$mois,$jour,$annee))], $tdate);
		$tdate = str_replace('%monthlong%', $lang['moistab'][$mois], $tdate);
	}
	// graph
	else
	{
		$tdate = str_replace('%dayshort%', $lang['jsemaine_graph'][date("D",mktime(0,0,0,$mois,$jour,$annee))], $tdate);
		$tdate = str_replace('%monthshort%', $lang['moistab_graph'][$mois], $tdate);
	}

	// on remplace les autres occurrences
	$tdate = str_replace('%daynumeric%', $jour, $tdate);
	$tdate = str_replace('%yearlong%', $annee, $tdate);

	$tdate = str_replace('%daynumeric2%', $aff_jour_fin, $tdate);
	if ($aff_mois_fin != 0) $tdate = str_replace('%monthlong2%', $lang['moistab'][$aff_mois_fin], $tdate);
	$tdate = str_replace('%monthnumeric%', $mois, $tdate);

	// on retourne la date formatée
	return $tdate;
}

// affiche pourcentage en fonction d'une chane modle (compatible i18n)
function print_nb_percent($nb,$pc,$str)
{
	global $lang;

	if ($lang['text_dir'] == "rtl")
	{
		printf($str,"<small>(".$pc."%)</small> <strong>".$nb." </strong>\n");
	}
	else
	{
		printf($str,"<strong>".$nb." </strong> <small>(".$pc."%)</small>");
	}
	print("<br /><br />");
}
// teste si l'url est correcte 
function is_url( $url ) 
{ 
	if (!($parts = parse_url($url))) 
		return false; 
	else { 
		if ($parts['scheme'] != "http" && $parts['scheme'] != "https") 
		{
			return false; }
		elseif( (!eregi( "^[0-9a-z]([-.]?[0-9a-z])*\.[a-z]{2,4}$", $parts['host'], $regs) && !eregi( "^[0-9a-z]*$", $parts['host'], $regs)) && !is_ip($parts['host'])) 
		{
			return false; }
		elseif(!@eregi( "^[0-9a-z/_\.@~%]*$", $parts['path'], $regs))
		{
			return false; }
		elseif($url[strlen($url)-1]!='/')
		{
			return false; }
		} 
	return true; 
}

// teste la validit d'une IP
function is_ip($ip){
 if(!is_string($ip))
  return false;
  $ip_reverse = @long2ip(@ip2long($ip));
  if($ip == $ip_reverse)
  return true;
  else
  return false;
}

// si changements faire de mme dans phpmyvisites.php
// supprime les espaces dans les chaines (vs sql_injection)
function del_spaces($string)
{
	$string = str_replace(' ','',$string);
	return $string;
}

// si changements faire de mme dans phpmyvisites.php
// test numeric
function testnum($string)
{
	if(!is_numeric($string)){ exit(); }
}

// retourne le numero du jour du debut de la semaine 
//  laquelle appartient la date $date
function jour_debut_semaine($date)
{
	// on extrait les infos de la date du jour
	$datx = explode('-', $date);
	$annee = $datx[0];
	$mois = $datx[1];
	$jour = $datx[2];

	// on prend le numero de la semaine dans l'anne
	$numero_semaine = date("W",mktime(0,0,0,$mois,$jour,$annee));
	
	// puis le numro du jour dans la semaine
	$numero_jour_semaine = date("w",mktime(0,0,0,$mois,$jour,$annee));
	
	// on fait une petite opration pour avoir la date du dbut de la semaine
	$date_debut = date("Y-m-d", mktime(0,0,0,$mois,($jour-($numero_jour_semaine+6)%7),$annee));

	// et on la retourne
	return $date_debut;
}

// rogne les pages, url, mots cls
function rogne_pv($page)
{
	if(ROGNE_PV)
	{
		// on rogne les pages trop longues (ainsi que les mots cl et URLS)
		if(strlen($page)>69) { $page=substr($page,0,69)."..."; }
	}
	return htmlspecialchars($page);
}

// purge si ncessaire l'enregistrement dat du $date dans la table d'archive $table
function purge($date,$table)
{
	// flag de prob de purge (test  la fin pour l'affichage "ok" ou "probleme")
	global $prob_purge;
	$sel_done = mysql_query("SELECT done,id FROM ".$table." WHERE  date='".$date."' ORDER BY done DESC LIMIT 1");

	$sel_doneb=mysql_fetch_row($sel_done);
	if($sel_doneb)
	{
		$done=$sel_doneb[0];
		$id=$sel_doneb[1];
		if($done!=3)
		{
			// on purge
			$req_purge = mysql_query("UPDATE ".$table." SET done=3, vis_hs='', vis_hl='',	pv_hs='',	pv_hl='',	hit_pv='',	hit_nbpv='',	hit_time='',	pv_debut='',	pv_fin='',	suivi='',	pays='',	fai='',	os='',	navig='',	resol='',	coul='',	moteurs='',	 mots='',	sitesrefs='' WHERE done='".$done."' AND id='".$id."'");
			if(!$req_purge)
			{
				$prob_purge=1;
				print("Problme : ".mysql_error());
			}
			//print("<br />");
		}
	}// if($sel_doneb)
}

// renvoie tableau contenant le nom des tables
function c_tables()
{
	global $table ,$table_pv,$table_suivi,$table_ajours,$table_asemaines,$table_amois;
	return array($table ,$table_pv,$table_suivi,$table_ajours,$table_asemaines,$table_amois);
}

// renvoie le tableau des semaines (utilis dans la purge)
function c_list_semaines($ts_init_phpmv)
{
	$t=$ts_init_phpmv;
	$i=0;
	while($t < time())
	{
		//$dt = date("Y-m-d", $t);
		$list_semaines_phpmv[$i]=$t;
		//print("$i : ".date("Y-m-d",$t)."<br />");
		$i++;
		$t+=7*24*3600;
	}
	return $list_semaines_phpmv;
}

// donnes indispensables pour la purge
function c_infos_purge($ts_init_phpmv)
{

	// dfinir le dernier jour que l'on peut archiver (le plus rcent donc)
	// il n'est ni dans le mois courant, ni dans la semaine courante
	$t=time();
	$i=0;
	while(date("m",$t)==date("m") || date("W",$t)==date("W"))
	{
		$t-=86400;
		$i++;
	}

	// nb de jours entre aujourd'hui et la dernire date archivable
	$nb_jours_sec=$i;

	//print("Le 1er jour ok est ".date("d-m-Y",$t)."<br />");
	$ts=$ts_init_phpmv;
	$i=0;

	// on construit la liste des jours qu'il est possible de purger
	// (entre date init et la derniere date possible de purger)
	// infos stockes dans $list_jours_phpmv
	while($ts<$t)
	{
		$list_jours_phpmv[$i]=date("Y-m-d",$ts);
		$ts+=86400;
		$i++;
	}

	// nb jours qu'il est possible de purger
	$nb_jours_tot = $i-1;

	// test du dernier jour bien prsent  la fin du tableau
	if(isset($list_jours_phpmv) && $list_jours_phpmv[$i-1]!=date("Y-m-d",$t)){ $list_jour_phpmv[$i-1] =date("Y-m-d",$t); }

	//printr($list_jours_phpmv);

	// tableau contenant tous les jours
	if(isset($list_jours_phpmv) && is_array($list_jours_phpmv))
	{
		$list_jourst_phpmv = $list_jours_phpmv;
	}
	else
	{
		$list_jours_phpmv=array();
		$list_jourst_phpmv=array();
	}

	while($ts<time())
	{
		$dtrec=date("Y-m-d",$ts);
		if($dtrec!=date("Y-m-d"))
		{
			$list_jourst_phpmv[]=date("Y-m-d",$ts);
		}
		$ts+=86400;
	}

	$return[0]=$nb_jours_sec;
	$return[1]=$nb_jours_tot;
	$return[2]=$list_jours_phpmv;
	$return[3]=$list_jourst_phpmv;

	return $return;
}
// affiche les sites enregistrs (pour partie admin)
function aff_sites_registered($nombre_sites, $act, $texte)
{				
	$aff_tab_sites_modif = "<div class=\"centrer\">$texte</div> <br /><br />";

	for($i=1;$i<=$nombre_sites;$i++)
	{
		include "./nomsites.php";
		${'site'.$i} = explode('||',${'site'.$i});
		$tabsite[$i][0] = ${'site'.$i}[1];
		$tabsite[$i][1] =  ${'site'.$i}[2];
		$aff_tab_sites_modif .= "<div class=\"centrer\"><a href=\"index.php?part=config&amp;stats=0&amp;act=".$act."&amp;no_site=".$i."\">".$i." - ".$tabsite[$i][0]."</a></div>";
	}
	$aff_tab_sites_modif.= "<br /><br />";
	print($aff_tab_sites_modif);
}

// crer les 6 tables dans la BDD
function create_tables($prefixe)
{
	global $lang;

	// cration phpmv
	$creation_table1 = mysql_query("
	CREATE TABLE `".$prefixe."` (  
		`id` mediumint(7) unsigned NOT NULL auto_increment,
		`nv` tinyint(1) unsigned NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		`time` time NOT NULL default '00:00:00',
		`stime` time NOT NULL default '00:00:00',
		`ttime` mediumint(5) unsigned NOT NULL default '0',
		`referrer` varchar(255) NOT NULL default '',
		`pv_debut` varchar(255) NOT NULL default '',
		`pv_fin` varchar(255) NOT NULL default '',
		`nb_pv` smallint(4) unsigned NOT NULL default '0',
		`host` varchar(100) NOT NULL default '',
		`ip` varchar(20) NOT NULL default '',
		`os` char(3) NOT NULL default '',
		`navig` varchar(6) NOT NULL default '',
		`resol` varchar(9) NOT NULL default '',
		`coul` tinyint(2) unsigned NOT NULL default '0',
		`pays` char(2) NOT NULL default '',
		`lang_navig` varchar(10) NOT NULL default '',
		`agent` varchar(150) NOT NULL default '',
		KEY `id` (`id`),
		KEY `date` (`date`)
		) TYPE=MyISAM
	");

	// cration phpmv_ajours
	$creation_table2 = mysql_query("
	CREATE TABLE `".$prefixe."_ajours` (
		`id` smallint(5) unsigned NOT NULL auto_increment,
		`done` tinyint(1) NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		`visiteurs` mediumint(8) unsigned NOT NULL default '0',
		`vis` mediumint(8) unsigned NOT NULL default '0',
		`vis_hs` text NOT NULL,
		`vis_hl` text NOT NULL,
		`pv` mediumint(8) unsigned NOT NULL default '0', 
		`pv_hs` text NOT NULL,
		`pv_hl` text NOT NULL,
		`pv_diff` smallint(5) unsigned NOT NULL default '0',
		`pv_max` smallint(5) unsigned NOT NULL default '0',
		`vis1pv` smallint(5) unsigned NOT NULL default '0', 
		`hit_pv` longtext NOT NULL,
		`hit_nbpv` text NOT NULL,
		`hit_time` text NOT NULL,
		`sum_time` mediumint(8) unsigned NOT NULL default '0',
		`pv_debut` longtext NOT NULL,
		`pv_fin` longtext NOT NULL,
		`suivi` longtext NOT NULL,
		`pays` text NOT NULL,
		`fai` longtext NOT NULL,
		`os` text NOT NULL,
		`navig` text NOT NULL,
		`resol` text NOT NULL,
		`coul` varchar(255) NOT NULL default '',
		`moteurs` longtext NOT NULL,
		`mots` longtext NOT NULL,
		`sitesrefs` longtext NOT NULL,
		`nb_moteurs` smallint(5) unsigned NOT NULL default '0',
		`nb_sites` smallint(5) unsigned NOT NULL default '0',
		`nb_direct` smallint(5) unsigned NOT NULL default '0',
		KEY `id` (`id`),
		KEY `date` (`date`)
		)
		TYPE=MyISAM
	");

	// cration phpmv_amois
	$creation_table3 = mysql_query("
	CREATE TABLE `".$prefixe."_amois` (
		`id` smallint(5) unsigned NOT NULL auto_increment,
		`done` tinyint(1) NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		`date_fin` date NOT NULL default '0000-00-00',
		`visiteurs` mediumint(8) unsigned NOT NULL default '0',
		`vis` mediumint(8) unsigned NOT NULL default '0',
		`vis_hs` text NOT NULL,
		`vis_hl` text NOT NULL,
		`pv` mediumint(8) unsigned NOT NULL default '0',
		`pv_hs` text NOT NULL,
		`pv_hl` text NOT NULL,
		`pv_diff` smallint(5) unsigned NOT NULL default '0',
		`pv_max` smallint(5) unsigned NOT NULL default '0',
		`vis1pv` smallint(5) unsigned NOT NULL default '0',
		`hit_pv` longtext NOT NULL,
		`hit_nbpv` text NOT NULL,
		`hit_time` text NOT NULL,
		`sum_time` mediumint(8) unsigned NOT NULL default '0',
		`pv_debut` longtext NOT NULL,
		`pv_fin` longtext NOT NULL,
		`suivi` longtext NOT NULL,
		`pays` text NOT NULL,
		`fai` longtext NOT NULL,
		`os` text NOT NULL,
		`navig` text NOT NULL,
		`resol` text NOT NULL,
		`coul` varchar(255) NOT NULL default '',
		`moteurs` longtext NOT NULL,
		`mots` longtext NOT NULL,
		`sitesrefs` longtext NOT NULL,
		`nb_moteurs` smallint(5) unsigned NOT NULL default '0',
		`nb_sites` smallint(5) unsigned NOT NULL default '0',
		`nb_direct` smallint(5) unsigned NOT NULL default '0',
		KEY `id` (`id`),
		KEY `date` (`date`)
		) TYPE=MyISAM
		");


	// cration phpmv_asemaines
	$creation_table4 = mysql_query("
		CREATE TABLE `".$prefixe."_asemaines` (
		`id` smallint(5) unsigned NOT NULL auto_increment,
		`done` tinyint(1) NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		`date_fin` date NOT NULL default '0000-00-00',
		`visiteurs` mediumint(8) unsigned NOT NULL default '0',
		`vis` mediumint(8) unsigned NOT NULL default '0',
		`vis_hs` text NOT NULL,
		`vis_hl` text NOT NULL,
		`pv` mediumint(8) unsigned NOT NULL default '0',
		`pv_hs` text NOT NULL,
		`pv_hl` text NOT NULL,
		`pv_diff` smallint(5) unsigned NOT NULL default '0',
		`pv_max` smallint(5) unsigned NOT NULL default '0',
		`vis1pv` smallint(5) unsigned NOT NULL default '0',
		`hit_pv` longtext NOT NULL,
		`hit_nbpv` text NOT NULL,
		`hit_time` text NOT NULL,
		`sum_time` mediumint(8) unsigned NOT NULL default '0',
		`pv_debut` longtext NOT NULL,
		`pv_fin` longtext NOT NULL,
		`suivi` longtext NOT NULL,
		`pays` text NOT NULL,
		`fai` longtext NOT NULL,
		`os` text NOT NULL,
		`navig` text NOT NULL,
		`resol` text NOT NULL,
		`coul` varchar(255) NOT NULL default '',
		`moteurs` longtext NOT NULL,
		`mots` longtext NOT NULL,
		`sitesrefs` longtext NOT NULL,
		`nb_moteurs` smallint(5) unsigned NOT NULL default '0',
		`nb_sites` smallint(5) unsigned NOT NULL default '0',
		`nb_direct` smallint(5) unsigned NOT NULL default '0',
		KEY `id` (`id`),
		KEY `date` (`date`)
		) TYPE=MyISAM
	");


	// cration phpmv_pv
	$creation_table5 = mysql_query("
		CREATE TABLE `".$prefixe."_pv` (
		`id` smallint(5) unsigned NOT NULL auto_increment,
		`page` varchar(255) NOT NULL default '',
		`nb` smallint(5) unsigned NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		KEY `id` (`id`),
		KEY `page` (`page`)
		) TYPE=MyISAM
	");

	// cration phpmv_suivi
	$creation_table6 = mysql_query("
		CREATE TABLE `".$prefixe."_suivi` (
		`id` mediumint(8) unsigned NOT NULL auto_increment,
		`page1` varchar(255) NOT NULL default '',
		`page2` varchar(255) NOT NULL default '',
		`nb` smallint(5) unsigned NOT NULL default '0',
		`date` date NOT NULL default '0000-00-00',
		KEY `id` (`id`),
		KEY `date` (`date`)
		) TYPE=MyISAM
	");

	// si les 6 tables ont t cres avec succs
	if($creation_table1 && $creation_table2 && $creation_table3 && $creation_table4 && $creation_table5 && $creation_table6)
	{
		// message de cration des tables
		print("<p class=\"admininfos\">".$lang['install_creationtables']);
		print("<span class=\"positif\">".$lang['install_ok']."</span></p>");
		return true;
	}
	// sinon on retourne l'erreur
	// certainement due  l'existence de la table de mme nom dans la base
	else
	{
		//".mysql_errno()." 
		print "<div class=\"centrer\"><span class=\"negatif\">".$lang['install_probleme'].utf8_encode(mysql_error())."</span></div>";
		print "<br /><div class=\"centrer\"><em>".$lang['install_erreurmiseajournormale']."</em></div>";
		return false;
	}
}

// affiche le formulaire d'ajout/modification d'un site
function printform_bddcfg($act,$act_eventuel='', $no_nvsite=1, $aff_back=1)
{
	// on rend global les infos du configx.php
	global $nom_site,$url_site,$user,$password,$host,$db,$prefixeglobal,$conditionsget,$lesget;
	global $lang;

	// si on est a l'install
	if($act=='install_1')
	{ 
		// on donne la possibilit de transformer prfixe
		$type_champ_prefixe='text';
		$value='phpmv';
		$aff_prefixe='';
		$allget_oui = "";
		$allget_non = " checked=\"checked\"";
		$conditionsget[1]=$lesget;
	} 
	// cas d'une modification
	elseif($act=='modif_site')
	{
		include "./config".$no_nvsite.".php";
		include "./nomsites.php";

		// on prend les infos sur le site (cas de modification)
		${'site'.$no_nvsite} = explode('||',${'site'.$no_nvsite});
		$nom_site = ${'site'.$no_nvsite}[1];
		$url_site =${'site'.$no_nvsite}[2];
	
		// prefixe = prfixe d'un nom de table
		$prefixe=explode('_',$table); 
		$value=$prefixe[0];
		$aff_prefixe='';
		$type_champ_prefixe='text';
		
		// si on ne tiens pas compte des paramtres GET, $allget = true
		if ($conditionsget[0])
		{
			$allget_oui = " checked=\"checked\"";
			$allget_non = "";
		} else {
			$allget_oui = "";
			$allget_non = " checked=\"checked\"";
		}

	}
	// cas d'un ajout
	else
	{ 
		// possib de mettre hidden pour dsactiver le changement du nom
		$type_champ_prefixe='text';
		include "./config1.php";
		
		// sinon le prfixe est 'ancienprfixe'.$no_nvsite
		$prefixe=explode('_',$table); 
		$prefixe=$prefixe[0];
		$value=$prefixe.$no_nvsite;
		$aff_prefixe='';
		$allget_oui = "";
		$allget_non = " checked=\"checked\"";
		$conditionsget[1]="";
	}
	
	// password affich si ADMIN sur TRUE
	if(!ADMIN)
	{
		$user='';
		$host='';
		$db='';
		$password='';
	}

	// affichage du formulaire avec les valeurs enregistres ou valeurs par dfaut

	// ATTENTION : valeur de oui et non inverss pour les paramtres GET
	// mettre allget  OUI signifie ne pas prendre en compte les paramtres
	// reformul car plus clair
	print("
	<form enctype=\"multipart/form-data\" method=\"post\" action=\"index.php?img=0&amp;part=config&amp;stats=0".$act_eventuel."\">\n\n
	<table class=\"centrer\" width=\"450\" cellpadding=\"5\">
	<tr>\n<td>".$lang['install_nomsite']."</td><td><input type=\"text\" name=\"nom_site\" value=\"$nom_site\" size=\"15\" maxlength=\"13\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_adressesite']."</td><td><input type=\"text\" name=\"url_site\" value=\"".htmlentities(stripslashes(urldecode($url_site)))."\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_loginmysql']."</td><td><input type=\"text\" name=\"user\" value=\"$user\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_mdpmysql']."</td><td><input type=\"password\" name=\"password\" value=\"$password\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_serveurmysql']."</td><td><input type=\"text\" name=\"host\" value=\"$host\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_basemysql']."</td><td><input type=\"text\" name=\"db\" value=\"$db\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_prefixetable']."</td><td>$aff_prefixe<input type=\"$type_champ_prefixe\" name=\"prefixe\" value=\"".$value."\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>". sprintf($lang['install_afficherlogo'],"<a href=\"http://www.phpmyvisites.net\"><img alt=\"".$lang['logo_description']."\" src=\"images/logo.png\" /></a>") ."</td><td> ".$lang['install_oui']." <input type=\"radio\" name=\"logo\" value=\"1\" checked=\"checked\" /> ".$lang['install_non']." <input type=\"radio\" name=\"logo\" value=\"0\" /></td>\n</tr>\n


	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n
	<tr>\n<td colspan=\"2\"><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;".$lang['install_utilisateursavances']."</strong> </td>\n</tr>\n
	<tr>\n<td>&nbsp;&nbsp;&nbsp;".$lang['install_variablesget']." </td><td>".$lang['install_oui']." <input type=\"radio\" name=\"allget\" value=\"non\"$allget_non /> ".$lang['install_non']." <input type=\"radio\" name=\"allget\" value=\"oui\"$allget_oui /> </td>\n</tr>\n
	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n
	<tr>\n<td>&nbsp;&nbsp;&nbsp;".$lang['install_explicationsget']."</td><td><input type=\"text\" name=\"lesget\" value=\"".$conditionsget[1]."\" size=\"25\" /></td>\n</tr>\n
	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n
	<tr>\n<td colspan=\"2\">\n
	<div class=\"centrer\">\n
	<input type=\"hidden\" name =\"$act\" value=\"$no_nvsite\" />
	<input type=\"submit\" name=\"config_bdd\" class=\"valid\" value=\" ".$lang['install_continuer']." \" />");
	if($aff_back==1)
	{ 
		print("<img src=\"images/pixel.png\" width=\"50\" height=\"1\" alt=\"pixel\" />
			 <input type=\"submit\" name=\"back\" class=\"valid\" value=\" ".$lang['install_annuler']." \" />");
	}
	print("</div>\n
	</td>\n</tr>\n
	</table>\n</form>\n
	");
}
	
// fonction inspire d'une fonction du script SYMPOLL
// [ www.ralusp.net ][ auteur : ralusp@ralusp.net ]
function chemin_phpmv()
{
		/* path,first check for cgi on php4 */
if(function_exists('php_sapi_name') && (php_sapi_name() == "cgi") &&
isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] != "") { 
 $phpmv_url_chemin = $_SERVER['PATH_INFO'];
 $cgi4 = TRUE;
} /* path,second try request_uri */
else if(isset($_SERVER['REQUEST_URI']) && $_SERVER['REQUEST_URI'] != "") {
 if($pos = strpos($_SERVER['REQUEST_URI'], "?")) {
$phpmv_url_chemin = substr($_SERVER['REQUEST_URI'], 0, $pos);
 } else {
$phpmv_url_chemin = $_SERVER['REQUEST_URI'];
 }
} /* path,third try redirect_url for proxies */
else if(isset($_SERVER['REDIRECT_URL']) && $_SERVER['REDIRECT_URL'] != "") { 
 $phpmv_url_chemin = $_SERVER['REDIRECT_URL'];
} /* path,fourth try document_uri for shtml */
else if(isset($_SERVER['DOCUMENT_URI']) && $_SERVER['DOCUMENT_URI'] != "") {
 $phpmv_url_chemin = $_SERVER['DOCUMENT_URI'];
} /* path,fifth default to php_self */
else if(isset($_SERVER['PHP_SELF']) && $_SERVER['PHP_SELF'] != "") {
 $phpmv_url_chemin = $_SERVER['PHP_SELF'];
}
	
	 /* hostname,first use config file */
if(isset($purl['host']) && $purl['host'] != "") {
 $phpmv_url_chemin = "$purl[host]$phpmv_url_chemin";
} /* hostname,second try server_name */
else if(isset($_SERVER['SERVER_NAME']) && $_SERVER['SERVER_NAME'] != "") {
 $phpmv_url_chemin = "$_SERVER[SERVER_NAME]$phpmv_url_chemin";
} /* hostname,third try http_host */
else if(isset($_SERVER['HTTP_HOST']) && $_SERVER['HTTP_HOST'] != "") {
 $phpmv_url_chemin = "$_SERVER[HTTP_HOST]$SYMP_URL";
}
	$phpmv_url_chemin="http://".$phpmv_url_chemin;
	return $phpmv_url_chemin;
}

// affiche le formulaire de personnalisation
function printform_perso($act='', $aff_back=1)
{
	global $nom_site,$url_site,$user,$pass,$chemin,$host,$db,$prefixe;
	global $lang;

	// si le fichier de config existe
	// le form sera rempli par les bonnes valeurs
	if(file_exists("./config.php")){ include "./config.php"; }
	// sinon les valeurs par dfauts affiches sont
	else{ $img=1; $login = 'admin'; $pass=''; $protect=0;
	
	$phpmv_url_chemin=chemin_phpmv();
	$chemin=substr($phpmv_url_chemin, 0, strrpos($phpmv_url_chemin, "/")+1);

	}
	// dbut du form
	$form ="
	<form enctype=\"multipart/form-data\" method=\"post\" action=\"index.php?part=config&amp;stats=0".$act."\">\n\n
	<table class=\"centrer\" width=\"600\" cellpadding=\"5\">";

	// login & password
	$form.="<tr>\n<td>".$lang['install_loginadmin']."</td><td><input type=\"text\" name=\"login\" value=\"$login\" size=\"15\" /></td>\n</tr>\n
	<tr>\n<td>".$lang['install_mdpadmin']."</td><td><input type=\"password\" name=\"pass\" value=\"".$pass."\" size=\"35\" /></td>\n</tr>\n
	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n";

	// chemin absolu de phpMyVisites
	$form.="<tr>\n<td>".$lang['install_chemincomplet']."</td><td><input type=\"text\" name=\"chemin\" value=\"$chemin\" size=\"35\" /></td>\n</tr>\n
	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n";

	// protection : soit ADMIN ET STATS soit ADMIN seulement
	$form.="<tr>\n<td>".$lang['install_rendrestatspubliques']."</td><td>".$lang['install_oui']." <input type=\"radio\" class=\"bouton\" name=\"protect\" value=\"0\"";
	if($protect==0){ $form.= " checked=\"checked\""; }
	$form.=" /></td>\n</tr>\n";
	$form.="<tr>\n<td>".$lang['install_nepasrendrestatspubliques']."</td><td> ".$lang['install_oui']." <input type=\"radio\" name=\"protect\" class=\"bouton\" value=\"1\"";
	if($protect==1){ $form.= " checked=\"checked\""; }
	$form.=" /></td>\n</tr>\n
	<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n";

	// graphiques $img
	$form.="<tr>\n<td>".$lang['install_affichergraphique']."</td><td> ".$lang['install_oui']." <input class=\"bouton\" type=\"radio\" name=\"img\" value=\"1\"";
	if($img==1){ $form.= " checked=\"checked\""; }
	$form.= " /> <br /> ".$lang['install_non']." <input class=\"bouton\" type=\"radio\" name=\"img\" value=\"0\"";
	if($img==0){ $form.= " checked=\"checked\""; }
	$form.= " /></td>\n</tr>\n";

	// fin du form
	$form.="<tr>\n<td colspan=\"2\">&nbsp;</td>\n</tr>\n
	<tr>\n
	<td colspan=\"2\">\n
	<div class=\"centrer\">\n
	<input type=\"submit\" name=\"config_perso\" class=\"valid\" value=\" ".$lang['install_valider']." \" />\n";
	if($aff_back==1)
	{ 
		$form.="<img src=\"images/pixel.png\" width=\"100\" height=\"1\" alt=\"pixel\" />\n
				<input type=\"submit\" name=\"back\" class=\"valid\" value=\" ".$lang['install_annuler']." \" />\n";
	}
	$form.="</div>\n
	</td>\n</tr>\n
	</table>\n</form>\n";

	// et affichage
	print($form);
}

// crer le fichier configX.php
function create_cfg_file($numero_site,$user,$pass,$host,$db,$prefixe,$allget,$lesget,$logo)
{
	global $lang;

	// cration du fichier configX.php ou crasement si dj existant
	print("<p class=\"admininfos\">".sprintf($lang['admin_creationfichier']," 'config".$numero_site.".php'... "));
	$file= @fopen("./config".$numero_site.".php" , "w");

	// si la cration a russie
	if($file)
	{
		// on y inscrit les infos en paramtres
		if(empty($allget)){$allget="\"\"";}
		fputs($file,"<?php\n\$user=\"".$user."\";\n\$password='".$pass."';\n\$db=\"".$db."\";\n\$host=\"".$host."\";\n\$table=\"".$prefixe."\";\n\$table_pv=\"".$prefixe."_pv\";\n\$table_suivi=\"".$prefixe."_suivi\";\n\$table_ajours=\"".$prefixe."_ajours\";\n\$table_asemaines=\"".$prefixe."_asemaines\";\n\$table_amois=\"".$prefixe."_amois\";\n\$conditionsget = array($allget,\"$lesget\");\n\$logo=\"".$logo."\";\n?>");
		fclose($file);

		// on print un beau ok et on retourne un magnifique true
		print("<span class=\"positif\">".$lang['install_ok']."</span></p>\n");
		return true;
	}
	// si la cration a chou
	else
	{
		// on print un message d'erreur 'bidon' (si vous avez une meilleur proposition ?)
		print("<span class=\"negatif\">".sprintf($lang['admin_creationfichier'],"</span></p>\n<p>".sprintf($lang['install_problemedroitfichier'],"\"config".$numero_site.".php\"","\"config".$numero_site.".php\""))."</p>\n");
		return false;
	}
}

// crer ou met a jour le fichier nomsites.php
function create_nomsites_file($numero_site,$nom_site,$url_site)
{
	global $lang;

	// cration du fichier nomsites.php ou crasement si dj existant
	print("<p class=\"admininfos\">".sprintf($lang['admin_creationfichier']," 'nomsites.php'... "));

	// on inclue nomsites.php si il prexiste
	if(file_exists("./nomsites.php"))
	{
		include "./nomsites.php";
	}
	$file= @fopen("./nomsites.php" , "w");

	// si la cration a russie
	if($file)
	{
		// on y inscrit les infos en paramtres
		fputs($file,"<?php\n");

		// si on ajout ou modifie le site 1
		if($numero_site==1)
		{
			// on print ses valeurs
			fputs($file,"\$site1=\"1||".addslashes($nom_site)."||".urlencode($url_site)."\";\n");
			// et les valeurs ventuelles d'autres sites
			// (si config.php existe donc)
			if(file_exists("./config.php"))
			{
				include "./config.php";
				for($i=2;$i<$nombre_sites+1;$i++)
				{
					$tabsite_i=explode('||',${'site'.$i});
					fputs($file,"\$site".$i."=\"".$i."||".$tabsite_i[1]."||".$tabsite_i[2]."\";\n");
				}
			}
		}
		// sinon on met a jour normalement 
		else
		{
			// en bouclant les sites existant et en les rcrivant
			for($i=1;$i<$numero_site;$i++)
			{
				fputs($file,"\$site".$i."=\"".${'site'.$i}."\";\n");
			}
			// et on rajoute la dernire ligne modifie ou ajoute
			fputs($file,"\$site".$numero_site."=\"".$numero_site."||".addslashes($nom_site)."||".urlencode($url_site)."\";\n");

		}
		fputs($file,"?>");
		fclose($file);

		// on print un beau ok et on retourne un magnifique true
		print("<span class=\"positif\">".$lang['install_ok']."</span></p>\n");
		return true;
	}
	// si la cration a chou
	else
	{
		// on print un message d'erreur 'bidon' (si vous avez une meilleur proposition ?)
		print("<span class=\"negatif\">".$lang['install_erreur']."</span></p><p>".sprintf($lang['install_problemedroitfichier'],"\"nomsites.php\"","\"nomsites.php\"")."</p>\n");
		return false;
	}
}

// affiche Ok en vert
function printok()
{
	global $lang;
	print("<span class=\"positif\">".$lang['install_ok']."</span></p>\n");
}

// affiche Erreur en rouge
function printprob()
{
	global $lang;
	print("<span class=\"negatif\">".$lang['install_erreur']."</span>");
}

// regarde si le password correspond au mot de passe du fichier config.php
// si oui alors on le laisse tel quel, car il est dj crypt il ne faut pas le recrypter
// si non il est en clair (le user l'a chang) donc on le crypt
function check_passwd($password)
{
	if(file_exists("./config.php"))
	{
		include "./config.php";
	}

	// si mme password on le crypte pas car dj crypt
	if(isset($pass) && $password==$pass) { $passtosave=$password; }
	// sinon on crypte
	else {$passtosave=crypt($password,'es'); }

	return $passtosave;
}

// crer le fichier config.php
function create_configphp($nombre_sites,$login,$password,$chemin,$protect,$img)
{
	global $lang;

	// cration du fichier nomsites.php ou crasement si dj existant
	print("<p class=\"admininfos\">".sprintf($lang['admin_creationfichier']," 'config.php'... "));
	
	$passtosave = check_passwd($password);

	$file= @fopen("./config.php" , "w");
	// si la cration a russie
	if($file)
	{
		// on y inscrit les infos en paramtres
		fputs($file,"<?php\n");
		fputs($file,"\$nombre_sites=".$nombre_sites.";\n\$login=\"".$login."\";\n\$pass='".$passtosave."';\n\$chemin=\"".$chemin."\"; \n\$protect=\"".$protect."\";\n\$img=\"".$img."\";\n");
		fputs($file,"?>");
		fclose($file);

		// on print un beau ok et on retourne un magnifique true
		printok();
		return true;
	}
	// si la cration a chou
	else
	{
		// on print un message d'erreur 'bidon' (si vous avez une meilleur proposition ?)
		printprob();
		print("<br /></p><p>".sprintf($lang['install_problemedroitfichier'],"\"nomsites.php\"","\"config.php\"")."</p>\n");
		return false;
	}
}

// affiche le code JS pour le site n$site spcifi
function print_codejs($site)
{
	global $lang;
	include "./config.php";
	print "<code>";
	print "&lt;a href=\"http://www.phpmyvisites.net/\" title=\"".addslashes($lang['logo_description'])."\" onclick=\"window.open(this.href);return(false);\"&gt;<br />";
	print "&lt;script type=\"text/javascript\"&gt;
	<br />&lt;!--<br />
	doc = document; d = new Date(); res = screen.width+\"x\"+screen.height; c = screen.colorDepth;<br />
	src = '<strong>".$chemin."phpmyvisites.php</strong>?url='+escape(doc.location.pathname+doc.location.search);<br />
	src += '&amp;<strong>site=".$site."</strong>&amp;res='+res;<br />
	src += '&amp;siteh='+doc.location.hostname+'&amp;c='+c+'&amp;h='+d.getHours()+'&amp;m='+d.getMinutes()+'&amp;s='+d.getSeconds();<br />
	doc.writeln('&lt;img src=\"'+src+'&amp;ref='+escape(doc.referrer)+'\" alt=\"phpMyVisites\" style=\"border:0\" /&gt;');<br />
	//--&gt;<br />
	&lt;/script&gt;<br />";
	print "&lt;noscript&gt;<br />
	&lt;p&gt;<br />
	".$lang['logo_description']." <br />
	&lt;img src=\"".$chemin."phpmyvisites.php?nojs=1\" alt=\"phpMyVisites\" style=\"border:0\" /&gt;<br />
	&lt;/p&gt;<br />
	&lt;/noscript&gt;<br />";
	print "&lt;/a&gt;<br />";
	print "</code>";
}

// enregistrement du site
function register_phpmv()
{
	global $chemin, $logo, $protect, $nombre_sites;
	
	if(file_exists("./nomsites.php") && file_exists("./config.php"))
	{
		include "./nomsites.php";
		include "./config.php";
		// pour chaque site
		// on explose et prend les infos
		for($i=1;$i<=$nombre_sites;$i++)
		{
			${'site'.$i} = explode('||',${'site'.$i});
			$tabsite[$i][0] = ${'site'.$i}[1];
			$tabsite[$i][1] =${'site'.$i}[2];
		}
	}
	// on envoie les infos : affichage du logo, protection ou non des stats => Dans un unique but de statistiques
	// et les infos url de phpmv et url et nom du site audit, simplement pour comptabiliser les users de l'appli
	// je ne demande rien en change du service rendu, si ce n'est de connatre le nombre d'utilisateurs !
	// Merci de votre collaboration
	print("<img src=\"http://www.phpmyvisites.net/register_users.php?url_phpmv=".urlencode($chemin)."&amp;url_site=".urlencode($tabsite[sizeof($tabsite)][1]).
		"&amp;nom=".utf8_encode($tabsite[sizeof($tabsite)][0])."&amp;logo=".$logo."&amp;protect=".$protect."\" width=\"0\" height=\"0\" alt=\" \" />");
}
// fonction de comparaison utilise pour le tri de tabs multidimensionnels
// o la valeur  trier est en [1]
function compare($l, $r)
{
	return ($r[1] - $l[1]);
}

// fonction de comparaison utilise pour le tri de tabs multidimensionnels
// o la valeur  trier est en [0]
function compare2($l, $r)
{
	return ($r[0] - $l[0]);
}

// fonction de comparaison utilise pour le tri de tabs multidimensionnels
function compare3($l, $r)
{
	return ($l - $r);
}
// fonction de comparaison utilise pour le tri de tabs multidimensionnels
// o la valeur  trier est en [2]
function compare4($l, $r)
{
	return ($r[2] - $l[2]);
}

// fonction de comparaison utilise pour les tableaux affluents
function comparephpmvsum($l, $r)
{
	return ($r['phpmvsum'] - $l['phpmvsum']);
}

// fonction de formatage d'un nombre de valeur $valeur, avec $prec chiffres significatifs et $virg chiffres aprs la virgule
function nombre_formate($valeur, $prec = 6, $virg = 0)
{
	global $lang;

	$n_unite = $lang['unites_bytes'][0];
	$val_to_return = $valeur;
	$virg_m = pow(10, $virg);
	$prec_h = pow(10, $prec);

	// pour chaque unite du tableau $lang['unites_bytes']
	for ($d = 6, $ex = 15; $d >= 1; $d--, $ex-=3 )
	{
		// si la valeur dans l'unit actuelle est trop leve par rapport aux paramtres dfinis
		if (isset($lang['unites_bytes'][$d]) && $valeur >= pow(10, $ex)*$prec_h)
		{
			// calcul de la nouvelle valeur dans l'unit plus grande
			// attention, 1ko = 1024 Octets
			$conv= pow(1024, $d) / $virg_m;
			$valeur = round($valeur / $conv ) /$virg_m;
			$n_unite = $lang['unites_bytes'][$d];
		}
	}

	// on retourne ensuite la valeur en distinguant de l'unit Octets ou non
	if ($n_unite != $lang['unites_bytes'][0])
	{
		// il y a une virgule
		$val_to_return = number_format($valeur, $virg, $lang['separateur_decimaux'], $lang['separateur_milliers']);
	}
	else
	{
		// en octets, pas de virgule
		$val_to_return = number_format($valeur, 0, $lang['separateur_decimaux'], $lang['separateur_milliers']);
	}

	// on retourne un tableau contenant la valeur et l'unit
	return array($val_to_return, $n_unite);
}

// affichage tableau
function printr($texte)
{
	print("<pre>");
	print_r($texte);
	print("</pre><br />\n");
}

// on affiche un <h2> avec devant un lien 'a name' et une image
function printh3($texte, $a_name=1)
{
	global $lang;
	print("\n<a id=\"ancre$a_name\"></a><h3><img src=\"./images/f1".$lang['text_dir'].".png\" alt=\"\" />$texte</h3>\n\n");
}

// on affiche un <h1>
function printh1($texte)
{
	print("<h1>$texte</h1>\n");
}

// fonction d'affichage des graphiques
// qui affiche ssi $img=1 dans 'config.php'
function printimg($url_img,$altimage)
{
	global $img;
	if($img!=0)
	{
		print("<div class=\"centrer\">\n\t<img src=\"".$url_img."\" alt=\"$altimage\" />\n</div>\n");
	}
}

//----------------------------------
// FONCTIONS D'AFFICHAGE DE TABLEAUX
//----------------------------------

// t = nombre de hits
// type = 1 :avec taux de sortie || 0 : normaux
// lim : nom de la var limite (doit etre diffrent a chaque fois)
function aff_tab_suivi($titre, $tableau_data, $t, $type, $prec_hm, $a_name, $url_site)
{
	
	global $hit_pv,$txtliens,$partie;
	global $lang;
	$url_site = substr(urldecode($url_site), 0, -1);

	//---------
	// LIMITES
	//---------
	$nb_a_afficher=20;

	// si pas de limite spcifie
	if(!isset($_GET[$prec_hm]))
	{
		$prec_hm_utilisee=0;
	}
	else
	{
		$prec_hm_utilisee=$_GET[$prec_hm];
	}

	$id_deb=($prec_hm_utilisee)*$nb_a_afficher;

	if($id_deb+$nb_a_afficher>sizeof($tableau_data))
	{ 
		$id_fin=sizeof($tableau_data);
	} 
	else 
	{
		$id_fin=$id_deb+$nb_a_afficher;
	}
	// FIN LIMITES

	// on affiche le titre h2 ainsi que l'info "de X  Y pages"
	$aff_id_deb = $id_deb;
	// si on est a la premire page, pour ne pas afficher "de 0  20"
	if($aff_id_deb==0)
	{
		$aff_id_deb='1';
	}
	printh3($titre.sprintf($lang['suivi_dea'],$aff_id_deb,$id_fin), $a_name);

	// AFFICHAGE TABLEAU
	print "<div class=\"centrer\">\n";
	print("<table class=\"resultats\" cellpadding=\"5\">\n<tr>\n\t<th>$titre</th>\n\t<th>".$lang['suivi_nombre']."</th>");
	if($type==1)
	{
		print("\n\t<th>".$lang['suivi_tauxsortie']."</th>");
	}
	print("\n</tr>");
	for ($i = $id_deb; $i < $id_fin; $i++)
	{
		// On regarde si on est sur une ligne pair ou impair pour alterner les couleurs de cellule
		if ($i % 2 != 0) {
			$maclass = " class=\"damier\"";
			$maclassalign = " class=\"damieralign\"";
		} else {
			$maclass = "";
			$maclassalign = " class=\"align\"";
		}

		print("<tr>\n\t");
		print("<td$maclassalign><a href=\"".htmlentities($url_site).htmlentities(urldecode($tableau_data[$i][0]))."\" onclick=\"window.open(this.href);return(false);\"><strong>".htmlentities(urldecode(rogne_pv($tableau_data[$i][0])))."</strong></a></td>\n\t");
		print("<td$maclass>".$tableau_data[$i][1] ." <small>(".round(($tableau_data[$i][1]/$t)*100,1)."%)</small></td>\n\t");

		// si page de sortie alors calcul du taux de sortie
		if($type==1)
		{
			// on calcule le taux de sortie : nb / hits page
			if(isset($hit_pv[$tableau_data[$i][0]]))
			{
				$percent = round($tableau_data[$i][1]/$hit_pv[$tableau_data[$i][0]]*100,1);
			}
			else
			{
				$percent='100';
			}
			print("<td$maclass>".$percent."%</td>\n\t");
		}
		print("</tr>\n");
	}
	print("</table>\n\n");
	print "</div>\n\n";
	
	// LIMITES
	print("<br /><br />\n<div class=\"centrer\">\n");
	// on affiche les liens pour les suivantes/prcdentes
	if($prec_hm_utilisee>0 && isset($prec_hm)) 
	{ 
		print("<a href=\"$txtliens&amp;part=".$partie."&amp;".$prec_hm."=".($prec_hm_utilisee - 1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlesprecedents'],$nb_a_afficher)."</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	}
	
	if(sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1))) 
	{ 
		print("<a href=\"$txtliens&amp;part=".$partie."&amp;".$prec_hm."=".($prec_hm_utilisee + 1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlessuivants'],$nb_a_afficher)."</a>");
	}
	print("</div>\n");

}

// transforme url index en / pour les stats
function index_slash($url)
{
	if( $url==urldecode("/") || 
		$url==urldecode("/index") || 
		$url==urldecode("/index.htm") || 
		$url==urldecode("/index.html") || 
		$url==urldecode("/index.php"))
		{ 
			$url='/';
		}
	return $url;
}

// affiche le tableau listant les traducteurs
function aff_tab_langs($lang_dispos)
{
	print "<table class=\"resultats\" cellpadding=\"5\">\n<tr>\n\t<th>Langue</th>\n\t<th>Traducteur</th>\n</tr>";

	foreach ($lang_dispos as $contactlangue) 
	{
		print "\n<tr>\n\t<td>".$contactlangue[0]."</td>\n\t<td><a href=\"mailto:".$contactlangue[5]."\">". $contactlangue[4]."</a></td>\n</tr>";
	}
	print "\n</table>\n\n<br />";

}

// fonction d'affichage du SUIVI
// avec limites calcules spcialement pour le suivi, fonction des hits de chaque page  analyser
function aff_tab_suivi2($titre, $tableau_data, $page1, $t, $prec_hm, $a_name, $mess='')
{
	global $txtliens, $partie;
	global $lang;

	// on commmence par assigner les valeurs de la page a analyser dans le tab_aff
	// de la forme 0 => (page1,page2,hit) avec page1 : 'pv_ana'
	$j=0; $total_nbpages=0;
	$page1_len = strlen($page1);
	for ($i = 0; $i < sizeof($tableau_data); $i++)
	{

		// bug dans suivi : on cherche 'index' dans les refs
		// mais les refs n'indique pas index dans la 1.0 mais leur vraie valeur => corrig en 1.1
		// maintenant tout indique '/'
		if($page1=='/' || $page1=='index'){ $bug_index=true; } // il faut faire attention  la page1
		else{$page_a_tester=$page1; } // attitude normale

		// on teste si la page vue est la mme (on regarde a partir de la fin le nb de caractres de la page)
		// si le bug ou il cherche 'index' dans les refs
		// alors on cherche / ou index.php ou index.htm ou /index
		
		if(
			(!isset($bug_index) && substr($tableau_data[$i][0], -$page1_len) == $page_a_tester)
			||
				(
					isset($bug_index) && (substr($tableau_data[$i][0], -1) == '/' || substr($tableau_data[$i][0], -6) == '/index' || substr($tableau_data[$i][0], -10) == '/index.htm' || substr($tableau_data[$i][0], -11) == '/index.html' || substr($tableau_data[$i][0], -10) == '/index.php')
				)
			)
		{
			printdebug("trouv $page1 (".urldecode($tableau_data[$i][0]).") => ".$tableau_data[$i][1]."<br />");
			$tab_aff[$j][0] = urldecode($page1);
			$tab_aff[$j][1] = urldecode($tableau_data[$i][1]);
			$tab_aff[$j][2] = $tableau_data[$i][2];
			$total_nbpages += $tableau_data[$i][2];
			$j++;
		}
	}
	
	//---------
	// LIMITES
	//---------

	$nb_a_afficher=10;
	// si pas de limite spcifie
	if(!isset($_GET[$prec_hm])) 
	{
		$prec_hm_utilisee=0;
	}
	else
	{
		$prec_hm_utilisee=$_GET[$prec_hm];
	}

	$id_deb=($prec_hm_utilisee)*$nb_a_afficher;

	// on calcule le nombre de lignes a afficher en fonction de la taille de tab_aff
	if($id_deb+$nb_a_afficher>sizeof($tab_aff))
	{ 
		$id_fin=sizeof($tab_aff);
	} 
	else 
	{ 
		$id_fin=$id_deb+$nb_a_afficher;
	}


	// on affiche le titre h2 ainsi que l'info "de X  Y pages"
	$aff_id_deb = $id_deb;
	// si on est a la premire page, pour ne pas afficher "de 0  20"
	if($aff_id_deb==0)
	{
		$aff_id_deb='1'; 
	}
	printh3($titre.sprintf($lang['suivi_dea'],$aff_id_deb,$id_fin), $a_name);

	if(isset($mess))
	{
		if(!empty($mess))
		{
			print("$mess");
		}
	}
	// AFFICHAGE TABLEAU
	print(sprintf($lang['suivi_pageselectionnee'],"<strong>".$page1."</strong>")." <br /><br /><br />");
	print "<div class=\"centrer\">\n\n";
	print "<table class=\"resultats\" cellpadding=\"5\">\n<tr>\n\t<th>".$titre."</th>\n\t<th>".$lang['suivi_nombre']."</th>\n</tr>\n";

	// affichage
	for ($i = $id_deb; $i < $id_fin; $i++)
	{		
			// On regarde si on est sur une ligne pair ou impair pour alterner les couleurs de cellule
			if ($i % 2 != 0) {
				$maclass = " class=\"damier\"";
				$maclassalign = " class=\"damieralign\"";
			} else {
				$maclass = "";
				$maclassalign = " class=\"align\"";
			}
			print("<tr$maclassalign>\n\t<td$maclass>\n\t\t");
			print(rogne_pv($tab_aff[$i][0])."<br />\n\t\t<div class=\"centrer\"><img src=\"images/f2.png\" alt=\" \" /></div>\n\t\t &nbsp;&nbsp;<a href=\"$txtliens&amp;part=suivi&amp;pv_ana=".urlencode($tab_aff[$i][1])."#ancre".$a_name."\">".rogne_pv($tab_aff[$i][1])."</a>\n\t</td>\n\t<td$maclass>". $tab_aff[$i][2]."<small> (".round(($tab_aff[$i][2]/$total_nbpages)*100,1)."%)</small></td>\n</tr>\n");
	}

	print("</table>\n\n");
	print "</div>\n";
	
	if(($prec_hm_utilisee>0 && isset($prec_hm)) | (sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1)))) print("<br /><br /><div class=\"centrer\">");
	// on affiche les liens pour les suivantes/prcdentes
	if($prec_hm_utilisee>0 && isset($prec_hm)) 
	{ 
		print("<a href=\"$txtliens&part=".$partie."&".$prec_hm."=".($prec_hm_utilisee - 1)."&pv_ana=".urlencode($page1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlessuivants'],$nb_a_afficher)."</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	}
	
	if(sizeof($tab_aff)>($nb_a_afficher*($prec_hm_utilisee+1))) 
	{
		print("<a href=\"$txtliens&part=".$partie."&".$prec_hm."=".($prec_hm_utilisee + 1)."&pv_ana=".urlencode($page1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlessuivants'],$nb_a_afficher)."</a>");
	}
	if(($prec_hm_utilisee>0 && isset($prec_hm)) | (sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1)))) print("</div>");

}

// tableau_data de la forme : $tableau_data[$i][0] dans la cellule de gauche $tableau_data[$i][1] dans celle de droite
function aff_tab_config($titre, $tableau_data, $t, $prec_hm, $a_name,$nb_a_afficher=10, $url_site_to_analyse=-1, $tab_sd='',$str_th_1='')
{
	global ${$prec_hm},$txtliens, $partie, $prec_hste_moteurs_reversed;
	global $lang;

	// teste si tab des pays auquel cas on ne fait pas le utf8_encode car dj encod
	if($titre!=$lang['provenance_pays'] && $titre!=$lang['provenance_continent']){ $utf8encode=true; }

	// pour liens limites
	if(isset($_GET['pm'])) $partie=$partie."&pm=".$_GET['pm'];
	//---------
	// LIMITES
	//---------

	// si pas de limite spcifie
	if(!isset($_GET[$prec_hm]))
	{
		$prec_hm_utilisee=0;
	}
	else
	{
		$prec_hm_utilisee=$_GET[$prec_hm];
	}

	$id_deb=($prec_hm_utilisee)*$nb_a_afficher;

	if($id_deb+$nb_a_afficher>sizeof($tableau_data)) 
	{ 
		$id_fin=sizeof($tableau_data); 
	} 
	else
	{ 
		$id_fin=$id_deb+$nb_a_afficher;
	}
	
	///////////////
	// TABLEAUX
	///////////////
	print "<div class=\"centrer\">\n\n";
	print("<!-- result table -->\n");
	print("<table class=\"resultats\" cellpadding=\"5\">\n<tr>\n\t<th>$titre</th>\n\t<th>".$lang['provenance_nombre']."</th>\n</tr>\n");

	for ($i = $id_deb; $i < $id_fin; $i++)
	{
		if(isset($utf8encode)){ $superbetexte=utf8_encode($tableau_data[$i][0]); } else { $superbetexte=$tableau_data[$i][0]; }
		// On regarde si on est sur une ligne pair ou impair pour alterner les couleurs de cellule
		if ($i % 2 != 0) {
			$maclass = " class=\"damier\"";
			$maclassalign = " class=\"damieralign\"";
		} else {
			$maclass = "";
			$maclassalign = " class=\"align\"";
		}
		print("<tr>\n\t<td$maclassalign><strong>");
		print(str_replace('%url_beginning%', $txtliens ."&amp;part=". $partie ."&amp;". $prec_hm ."=". $prec_hm_utilisee, $superbetexte). "");
		print("</strong></td>\n\t<td$maclass>".$tableau_data[$i][1] ." (". round( ($tableau_data[$i][1]/$t)*100, 1)."%)</td>\n</tr>\n");

		// pour le site en cours, on affiche les dtails
		if($url_site_to_analyse==$tableau_data[$i][0])
		{
			print("<tr>\n\t<td colspan=\"2\">");
			print("\n\t\t<table id=\"detail\">\n\t\t<tr>\n\t\t\t");
			print("<th colspan=\"2\">");
			print("<img src=\"./images/f6".$lang['text_dir'].".png\" alt=\"\" />");
			print(utf8_encode($lang['affluents_details']));
			print("</th></tr>\n\t\t");
			$txtliens .= $_SERVER['REQUEST_URI'];
			if (strpos($txtliens,"souslim")) $txtliens = substr($txtliens, 0, strpos($txtliens,"souslim")-1);
			$monancre = "#ancre".$a_name;
			$tailletab = 20;
			if (isset($_GET['souslim'])) $souslim_utilisee = $_GET['souslim'];
				else $souslim_utilisee = 0;
			$debutvisu = $souslim_utilisee * $tailletab;
			$finvisu = $debutvisu + $tailletab;
			$finvisu = min($finvisu,sizeof($tab_sd));
			for($k=$debutvisu;$k<$finvisu;$k++)
			{
				if($titre==$lang['affluents_motscles'])
				{
					$prec_hen_debut="";
					$prec_hen_fin="";
				}
				elseif($titre==$lang['affluents_sitesinternet'])
				{
					$prec_hen_debut="<a href=\"".htmlentities($tab_sd[$k][0])."\" onclick=\"window.open(this.href);return(false);\">\n";
					$prec_hen_fin="</a>\n";
				}
				else
				{
					$prec_hen_debut="";	$prec_hen_fin="";
				}

				// on encode ou non
				if($titre!=$lang['affluents_motscles'])
				{
					if(isset($utf8encode)){ $superbetexte2=utf8_encode(rogne_pv($tab_sd[$k][0])); } else { $superbetexte2=rogne_pv($tab_sd[$k][0]); }
				}
				else
				{
					$superbetexte2=$tab_sd[$k][0];
				}
				print("<tr>\n\t\t\t<td>".$prec_hen_debut.$superbetexte2.$prec_hen_fin."</td>\n\t\t\t<td class=\"detail\">".$tab_sd[$k][1] ." (".round(($tab_sd[$k][1]/$tableau_data[$i][1])*100,1)."%)</td>\n\t\t</tr>\n\t\t");
			}
			print("</table>\n\n");
			// on affiche les liens pour les suivantes/prcdentes
			$suivantprecedent = "";
			if($souslim_utilisee>0) {
				$suivantprecedent = "<a href=\"$txtliens&amp;souslim=".($souslim_utilisee - 1).$monancre."\">&middot; ".sprintf($lang['generique_voirlesprecedents'],$tailletab)."</a>";
			}
			if ((sizeof($tab_sd) - $tailletab*$souslim_utilisee) > $tailletab) {
				$suivantprecedent .= "<a href=\"$txtliens&amp;souslim=".($souslim_utilisee + 1).$monancre."\">&middot; ".sprintf($lang['generique_voirlessuivants'],$tailletab)."</a>";
			}
			if ($suivantprecedent != "") {
				print("<div class=\"centrer\">");
				print $suivantprecedent;
				print("</div>");
			}
			print("</td>\n\t</tr>\n");
		}
	}
	print("</table>\n\n");
	print "</div>\n\n";
	

	//////////////
	// LIMITES
	//////////////
	if(($prec_hm_utilisee>0 && isset($prec_hm)) | (sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1)))) print("<br /><br />\n\n<div class=\"centrer\">\n\t");
	// on affiche les liens pour les suivantes/prcdentes
	if($prec_hm_utilisee>0 && isset($prec_hm))
	{
		print("<a href=\"$txtliens&amp;part=".$partie."&amp;".$prec_hm."=".($prec_hm_utilisee - 1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlesprecedents'],$nb_a_afficher)."</a>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
	}

	if(sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1)))
	{
		print("<a href=\"$txtliens&amp;part=".$partie."&amp;".$prec_hm."=".($prec_hm_utilisee + 1)."#ancre".$a_name."\">&middot; ".sprintf($lang['generique_voirlessuivants'],$nb_a_afficher)."</a>");
	}
	if(($prec_hm_utilisee>0 && isset($prec_hm)) | (sizeof($tableau_data)>($nb_a_afficher*($prec_hm_utilisee+1)))) print("\n</div>\n\n");
}

function aff_tab_langues($admin_pardefaut,$admin_supprimer)
{
	global $file,$default_lang;

	$handle=opendir("./langs");
	while ($file = readdir($handle)) {
		if ($file != "." && $file != ".." && $file != "index.php" && substr_count($file,'.php')!=0 && $file!='encode2utf8.php'&& $file!='autre.php'&& $file!='compare.php'&& $file!='show.php')
		{
			include "./langs/$file";
			// pour chaque fichier trouv ajout de la ligne correspondante. Le nom du boton de suppression est le nom du fichier  supprimer avec les points remplacs par %point% car ils ne passe pas dans les post
			print "<tr><td>";
			print $lang['lang_libelle_fr']." </td>";
			print "<td> ($file) </td>";
			if ($file == $default_lang) {
				print "<td> <em>$admin_pardefaut</em> </td><td> <em>$admin_pardefaut</em> </td></tr>";
			} else {
				print "<td> <input value=\" $admin_supprimer \" class=\"valid\" name=\"1".str_replace(".","%point%",$file)."\" type=\"submit\" /></td>";
				print "<td> <input value=\" $admin_pardefaut \" class=\"valid\" name=\"2".str_replace(".","%point%",$file)."\" type=\"submit\" /></td></tr>\n";
			}
		}
	}
	closedir($handle);
}

// parcours le repertoire langs et rcre le fichier langdispos.php
function recharge_lang($afficheinfos=true) {
	global $lang;

	// sauvegarde
	$lang2=$lang;
	
	if (!isset($lang['default_lang']))
			$lang['default_lang'] = "fr-utf-8.php"; // si le fichier n'existe pas on prends le franais comme langue par dfaut
	if ($afficheinfos) print("<p class=\"admininfos\">".sprintf($lang['admin_creationfichier']," 'langdispos.php'... "));
	$filelang= @fopen("./langdispos.php" , "w");

	// si la cration a russie
	if($filelang)
	{
		// on y inscrit les infos en paramtres
		fputs($filelang,"<?php\n");
		$handle=opendir("./langs");
		while ($file = readdir($handle)) {
			if ($file != "." && $file != ".." && $file != "index.php"&& $file != "autre.php" && substr_count($file,'.php')!=0 && $file!='encode2utf8.php'&& $file!='compare.php'&& $file!='show.php')
			{
				// pour les infos sur le traducteurs et la langue
				include "./langs/$file";
				// pour chaque fichier trouv ajout de la ligne correspondante dans le fichier langdispos.php.
				$param = "\$lang_dispos['".$file."'] = array('".$lang['lang_libelle_fr']."','".$lang['lang_libelle_en']."','".$lang['charset']."','".$lang['lang_iso']."','".$lang['auteur_nom']."','".$lang['auteur_email']."');\n";
				fputs($filelang,$param);
			}
		}

		closedir($handle);
		fputs($filelang,"\$default_lang = \"".$lang['default_lang']."\";\n?>");
		fclose($filelang);

		// on reprend les chanes de la bonne langue
		$lang=$lang2;

		// on print un beau ok et on retourne un magnifique true
		if ($afficheinfos) print("<span class=\"positif\">".$lang['generique_ok']."</span></p>\n");
		return true;
	}
	// si la cration a chou
	else
	{
		// on print un message d'erreur 'bidon' (si vous avez une meilleur proposition ?)
		if ($afficheinfos) print("<span class=\"negatif\">".$lang['admin_erreur']."</span><br />".sprintf($lang['install_problemedroitfichier'],"\"langdispos.php\"","\"langdispos.php\"")."</p>\n");
		return false;
	}
}

// affiche la slection des langues
function aff_choixlang() {
	global $lang;
	global $lang_dispos;

	print "\n<!-- lang selection -->\n<div id=\"choixlangue\">\n";
	print "<form action=\"".htmlentities($_SERVER['REQUEST_URI'])."\" method=\"post\">\n";
	print "<fieldset>\n";
	print "\t<legend>&nbsp;".$lang['generique_choixlangue']."&nbsp;</legend>\n";
	print "\t<select name=\"mylang\" onchange=\"this.form.submit()\" dir=\"".$lang['text_dir']."\">\n";

	// liste des langues dispos pour l'utilisateur (liste droulante)
	while (list($lefichier,$lelibelle) = each($lang_dispos))
	{
		print "\t\t<option value=\"$lefichier\"";

		// la langue actuelle est "selected"
		if ($lefichier == $lang['default_lang'] )//&& isset($_POST['mylang']) && $_POST['mylang']!='autre')
		print " selected=\"selected\"";

		print ">";

		// si fr alors on print en "fr", sinon en "en"
		if ($lang['lang_iso'] == "fr") print $lelibelle[0];
		else print $lelibelle[1];

		print "</option>\n";
	}
	print "\t\t<option value=\"autre\"";
	if(isset($_POST['mylang']))
	{
		if($_POST['mylang']=='autre'){ print " selected=\"selected\""; }
	}
	print ">".$lang['generique_autrelangure']."</option>\n";
	print "\t</select>\n";
	print "</fieldset>\n";
	print "</form>\n";
	print "</div>\n\n";
}
?>
