<?php
// +--------------------------------------------------------------------------+
// |   phpMyVisites   |   statistiques et mesure d'audience de sites Internet |
// +--------------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Matthieu Aubry. Tous droits rservs             |
// +--------------------------------------------------------------------------+
// | Ce code est distribu sous license GNU GPL, disponible  '/docs/licence' |
// | Pour toute information supplmentaire :     							  |
// | http://www.phpmyvisites.net    |    matthieu@phpmyvisites.net            |
// +--------------------------------------------------------------------------+

/*----------------------------------------------*/
// fichier : login.php
/*----------------------------------------------*/

// on affiche toutes les erreurs
@error_reporting (E_ALL);

// ne pas transformer
define('IN_PHPMV', TRUE);

// version en cours
require "./version.php";

// inclusion config et langs
include "./config.php";

// si changement, voir  index.php
$nomcookielg = "phpmv_lang";

// Cration du fichier de conf des langues s'il n'existe pas
if (!file_exists("./langdispos.php"))
	recharge_lang(false);

// fichier de conf des langues et chargement du tableau des libell de la langue utilise
include "./langdispos.php";

// si la langue ne vient pas d'tre change  l'aide de cookie
// donc si l'utilisateur vient pour la 1ere fois avec un browser sur phpmv la langue mise est celle def par dfaut dans l'admin
if (!isset($_POST['mylang']) || isset($lang_a_definir)) {
	if (isset($_COOKIE[$nomcookielg]) && file_exists("./langs/".$_COOKIE[$nomcookielg])) { // cas o l'utilisateur a fait son choix de langue avec le cookie et que la langue existe
		$lang['default_lang'] = $_COOKIE[$nomcookielg];
	} else { // si pas de cookie
		$lang['default_lang'] = $default_lang;
	}
}
// fichier de conf des langues et chargement du tableau des libell de la langue utilise
include "./langs/".$lang['default_lang'];

header("Content-Type: text/html; charset=".$lang['charset']);

// si protect les stats
if($protect==1)
{ 
	// on redirige vers la partie visites avec le bon message
	$go_to_part='index.php?part=visites';
	$message_private = sprintf($lang['login_private1'],"<a class=\"bleu\" href=\"http://www.phpmyvisites.net/\">","</a>");
}
// si on protge admin seulement
else
{ 
	// on redirige vers la partie config avec le bon message
	$go_to_part='index.php?part=config&amp;stats=0';
	$message_private= sprintf($lang['login_private2'],"<a class=\"bleu\" href=\"http://www.phpmyvisites.net/\">","</a>");
}

// pour cryptage
$salt='es';

// si le form a t valid
if(isset($_POST['adminlogin']) || isset($_POST['adminpass'])) 
{
	// si le log n'est pas correct
	if(($_POST['adminlogin']!=$login || crypt($_POST['adminpass'],$salt)!=$pass))
	{
		$erreur_login = true;
	}
	// si log ok
	elseif($_POST['adminlogin']==$login && crypt($_POST['adminpass'],$salt)==$pass)
	{
		$valid_login=true;
	}
}
// si premier affichage
else
{
	$affichage_form=true;
}

if(isset($erreur_login) || isset($affichage_form))
{
	// inclusion des tags html
	include "./include/header.php";
	print("\n\n\t<br /><br />\n\t<div class=\"centrer\">");

	// si un login/pass a t spcifi
	if(isset($_POST['adminlogin']) || isset($_POST['adminpass']))
	{ 
		// message d'erreur
		print("<strong><span class=\"negatif\">".$lang['login_error']."</span></strong>\n\n<br /><br />");
	}

	// affichage form
	print("
	<p>".$message_private." </p>
	<br />
	<form action=\"login.php\" method=\"post\">
		<table class=\"centrer\">
		<tr>
			<td> ".$lang['login_login']." </td>
			<td><input name=\"adminlogin\" maxlength=\"15\" type=\"text\" /></td>
		</tr>

		<tr>
			<td> ".$lang['login_password']." </td>
			<td><input name=\"adminpass\" type=\"password\" /></td>
		</tr>

		<tr>
			<td colspan=\"2\">
			<input type=\"hidden\" value=\"$go_to_part\" name=\"part\" /><br />
			<input name=\"ok\" type=\"submit\" class=\"valid\" value=\" ".$lang['install_valider']." \" />
			</td>
		</tr>
		</table>
	</form>
	</div>
</div>
</body>
</html>
	");
}
elseif(isset($valid_login))
{

	// on dmarre la session 'phpmv'
	session_name('phpmv'); 
	session_start(); 

	// on dfinit les variables de session
	$_SESSION['sadminlogin']=$_POST['adminlogin']; 
	$_SESSION['sadminpass']=crypt($_POST['adminpass'],$salt); 

	// et on redirige vers la bonne partie
	header("Location:./".str_replace("&amp;","&",$go_to_part));}
?>
